#ifndef CYGONCE_HAL_PLATFORM_INTS_H
#define CYGONCE_HAL_PLATFORM_INTS_H
//==========================================================================
//
//      hal_platform_ints.h
//
//      HAL Interrupt and clock support
//
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    Qiang Huang
// Contributors: None
// Date:         2003-01-22
// Purpose:      Define Interrupt support
// Description:  The interrupt details for the Altera/EPXA1 are defined here.
// Usage:
//               #include <cyg/hal/hal_platform_ints.h>
//               ...
//              
//
//####DESCRIPTIONEND####
//
//==========================================================================

#include <cyg/hal/epxa1.h>

// These are interrupts on the EPXA1

#define CYGNUM_HAL_INTERRUPT_PLD_0               0
#define CYGNUM_HAL_INTERRUPT_PLD_1               1
#define CYGNUM_HAL_INTERRUPT_PLD_2               2
#define CYGNUM_HAL_INTERRUPT_PLD_3               3
#define CYGNUM_HAL_INTERRUPT_PLD_4               4
#define CYGNUM_HAL_INTERRUPT_PLD_5               5
#define CYGNUM_HAL_INTERRUPT_EXTERNAL            6
#define CYGNUM_HAL_INTERRUPT_UART                7
#define CYGNUM_HAL_INTERRUPT_TIMER_0             8
#define CYGNUM_HAL_INTERRUPT_TIMER_1             9
#define CYGNUM_HAL_INTERRUPT_PLL                10
#define CYGNUM_HAL_INTERRUPT_EBI_ERROR          11
#define CYGNUM_HAL_INTERRUPT_PLD_ERROR          12
#define CYGNUM_HAL_INTERRUPT_AHB_ERROR          13
#define CYGNUM_HAL_INTERRUPT_COMMTX             14
#define CYGNUM_HAL_INTERRUPT_COMMRX             15
#define CYGNUM_HAL_INTERRUPT_FAST_COMMS         16

#define CYGNUM_HAL_INTERRUPT_NONE    -1

#define CYGNUM_HAL_ISR_MIN            0
#define CYGNUM_HAL_ISR_MAX            (CYGNUM_HAL_INTERRUPT_FAST_COMMS)

#define CYGNUM_HAL_ISR_COUNT          (CYGNUM_HAL_ISR_MAX-CYGNUM_HAL_ISR_MIN+1)

// The vector used by the Real time clock
#define CYGNUM_HAL_INTERRUPT_RTC      CYGNUM_HAL_INTERRUPT_TIMER_0

//----------------------------------------------------------------------------
// Reset.

// Writing a bad value to the watchdog reload register causes a reset.
#define HAL_PLATFORM_RESET() \
    HAL_WRITE_UINT32(EPXA1_WDOG_RELOAD, 0)

#define HAL_PLATFORM_RESET_ENTRY EPXA1_FLASH_PHYS_BASE

#endif // CYGONCE_HAL_PLATFORM_INTS_H
