
#include <cyg/hal/hal_diag.h>
#include <cyg/hal/epxa1.h>
#include <cyg/hal/hal_io.h>
#include <cyg/hal/hal_if.h>
#include <cyg/infra/diag.h>

//externC static hal_virtual_comm_table_t comm_channels[CYGNUM_HAL_VIRTUAL_VECTOR_NUM_CHANNELS+1];
externC void cyg_hal_plf_serial_putc(void *__ch_data, char c);


void printchar(unsigned char c)
{
    cyg_uint32 tsr;

    do {
        HAL_READ_UINT32(EPXA1_UART0_BASE + _UART_TSR, tsr);
        // Wait for TXI flag to be set - or for the register to be
        // zero (works around a HW bug it seems).
    } while (tsr && (tsr & _UART_TSR_TXI) == 0);

    HAL_WRITE_UINT32(EPXA1_UART0_BASE + _UART_TD, (cyg_uint32)(unsigned char)c);
}

void printword(cyg_uint32 word)
{

	unsigned char w0,w1,w2,w3,w4,w5,w6,w7;

	w0 = ( (unsigned char) (word&0x0f) );
	if(w0>0x09)
		w0+=0x37;
	else
		w0+=0x30;

	w1 = ( (unsigned char) ( (word>>4) & 0x0f ) );
	if(w1>0x09)
		w1+=0x37;
	else
		w1+=0x30;

	w2 = ((unsigned char)((word>>8)&0x0f));
	if(w2>0x09)
		w2+=0x37;
	else
		w2+=0x30;

	w3 = ((unsigned char)((word>>12)&0x0f));
	if(w3>0x09)
		w3+=0x37;
	else
		w3+=0x30;

	w4 = ((unsigned char)((word>>16)&0x0f));
	if(w4>0x09)
		w4+=0x37;
	else
		w4+=0x30;

	w5 = ((unsigned char)((word>>20)&0x0f));
	if(w5>0x09)
		w5+=0x37;
	else
		w5+=0x30;

	w6 = ((unsigned char)((word>>24)&0x0f));
	if(w6>0x09)
		w6+=0x37;
	else
		w6+=0x30;

	w7 = ((unsigned char)((word>>28)&0x0f));
	if(w7>0x09)
		w7+=0x37;
	else
		w7+=0x30;


	printchar(' ');
	printchar(w7);
	printchar(w6);
	printchar(w5);
	printchar(w4);
	printchar(w3);
	printchar(w2);
	printchar(w1);
	printchar(w0);
	printchar(' ');
	
}

void printmyname(void)
{
}


void printstr(unsigned char pstr[], unsigned int length)
{
	unsigned int cnt=0;
	for(cnt=0;cnt<length;cnt++)
	{
		printchar(pstr[cnt]);
	}
}





